# -*- coding: UTF-8 -*-
#
#   12.10.2015

import tkinter as tk
from tkinter import ttk

options = ["Scene 0", "Scene 1", "Scene 2", "Scene 3", "Scene 4", "Scene 5", "Scene 6", "Scene 7",
           "Scene 8", "Scene 9", "Scene 10", "Scene 11", "Scene 12", "Scene 13", "Scene 14", "Scene 15"]


class Combo(object):
    def __init__(self, master=None, column=0, columnspan=1, row=0, height=20, optionslist=options, width=8,
                 callback=None):
        self.optionslist = optionslist
        self.last_selection = 0
        self.master = master
        self.cb = callback
        self.combo = ttk.Combobox(self.master, values=optionslist, state="readonly",
                                  height=height, width=width)
        self.combo.set(self.optionslist[self.last_selection])
        self.combo.bind("<<ComboboxSelected>>", self._change_selection)
        self.combo.grid(column=column, columnspan=columnspan, row=row, padx=5, pady=5, sticky="nswe")

    def _change_selection(self, event):
        """ Wird bei jeder Änderung aufgerufen und schreibt die aktuelle
            Auswahl in die Variable last_selection
        """
        self.last_selection = event.widget.current()
        # print(self.last_selection, self.optionslist[self.last_selection])
        if self.cb is not None:
            self.cb(self.last_selection, self.optionslist[self.last_selection])

    def get_idx(self):
        """ Gibt den Index der zuletzt erfolgten Auswahl zurück """
        return self.last_selection

    def set_idx(self, idx):
        self.last_selection = idx
        self.combo.set(self.optionslist[idx])


if __name__ == "__main__":
    def main():
        # options = ("Option1 ", "Option 2", "Option 3")
        top = tk.Tk()
        frm = tk.Frame(top)
        frm.grid(column=0, row=0)

        Combo(master=frm, height=30, width=20)
        top.title("ttk Combobox")
        top.mainloop()

    main()
