#!/usr/bin/python
# -*- coding: UTF-8 -*-
#   12.10.2015

import tkinter as tk


class Switch(object):
    def __init__(self, canvas, x, y, room, length=13, group=None, callback=None):
        self.canvas = canvas
        self.group = group
        self.room = room
        self.is_power_on = True
        self.cb = callback

        lx = str(x - length // 2)
        ly = str(y - length // 2)
        rx = str(x + length // 2)
        ry = str(y + length // 2)

        fill_color = "blue"
        self.switch = canvas.create_arc(lx, ly, rx, ry, style=tk.CHORD, start=0, extent=359, fill=fill_color,
                                        width=2, outline="")
        canvas.create_text(str(x - int(length * 1.2)), str(y), text=self.group, font=("Helvetica", "10"),
                           justify=tk.CENTER)

        canvas.tag_bind(self.switch, '<1>', self.press_1)

    def press_1(self, e):

        if self.is_power_on:
            self.is_power_on = False

        # ausschalten
        else:
            self.is_power_on = True

        if self.cb:
            if self.is_power_on:
                self.cb(self.group, 254)
            else:
                self.cb(self.group, 0)
